summaryrefslogtreecommitdiff
path: root/gettext-tools/tests/msgfmt-6
diff options
context:
space:
mode:
Diffstat (limited to 'gettext-tools/tests/msgfmt-6')
-rwxr-xr-xgettext-tools/tests/msgfmt-630
1 files changed, 30 insertions, 0 deletions
diff --git a/gettext-tools/tests/msgfmt-6 b/gettext-tools/tests/msgfmt-6
new file mode 100755
index 0000000..aededbc
--- /dev/null
+++ b/gettext-tools/tests/msgfmt-6
@@ -0,0 +1,30 @@
+#! /bin/sh
+. "${srcdir=.}/init.sh"; path_prepend_ . ../src
+
+# Test catching of division by zero in plural expression.
+
+# Note: On AIX 3 with xlc, this test fails. To make it work, add "-qcheck"
+# to the CFLAGS, or use gcc.
+
+cat <<EOF > mf-6.po
+msgid ""
+msgstr ""
+"Project-Id-Version: msgfmt test 4\n"
+"PO-Revision-Date: 2001-09-23 15:03+0200\n"
+"Last-Translator: Bruno Haible <haible@clisp.cons.org>\n"
+"Language-Team: test <test@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=ASCII\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=3; plural=(1 + (1 / (n - 257)));\n"
+EOF
+
+: ${MSGFMT=msgfmt}
+${MSGFMT} --check -o mf-6.mo mf-6.po 2>/dev/null
+# Exit code must be 1.
+# If the division by zero didn't get noticed, it would be 0.
+# If it produced a core dump, it would be 136 (= 128 + SIGFPE).
+test $? = 1
+result=$?
+
+exit $result